## mingw-w64-blender-5.0.0-1.src.tar.zst

=== doc/python_api/requirements.txt ===
sphinx==8.2.3

# Sphinx dependencies that are important
Jinja2==3.1.6
Pygments==2.19.2
docutils==0.21.2
snowballstemmer==3.0.1
requests==2.32.4

# Only needed to match the theme used for the official documentation.
# Without this theme, the default theme will be used.
furo==2025.7.19
sphinx-basic-ng==1.0.0b2

# Show a copy button (convenience only).
sphinx-copybutton==0.5.2
